<?php
/*
 * Copyright (c) 2009, The members of Ouga! project
 * Etienne Deparis <etienne.deparis@umaneti.net>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 *
 * modification, are permitted provided that the following conditions are
 * met:
 *  - Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  - Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *  - Neither the name of the Ouga! project nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

$bdd_activ = null;

/**
 * Start a new bdd connexion
 * @return db_ressource
 */
function connectbdd(){
	global $bdd_activ;

	$dburl = OUGA_BDD_HOSTNAME; // adresse du serveur mySql
	$dbnom = OUGA_BDD_NAME; // nom de la base de donnée
	$dbuti = OUGA_BDD_USERNAME; // login de connexion à la base de donnée
	$dbmdp = OUGA_BDD_PASSWORD; // mot de passe de connexion à la base de donnée

	$bdd_activ = mysql_connect($dburl, $dbuti, $dbmdp) or die(mysql_error());
	mysql_select_db($dbnom, $bdd_activ) or die(mysql_error());
}

/**
 * Close active bdd connexion
 * @return void
 */
function bdd_close(){
	global $bdd_activ;
	mysql_close($bdd_activ);
}

function bdd_clean($ressource){
	mysql_free_result($ressource);
}

function bdd_is_activ(){
	global $bdd_activ;
	if($bdd_activ != null) return $bdd_activ;
	return false;
}

function bdd_add_prefix($query){
	$return = preg_replace('#\{(\w+)\}#iU',OUGA_BDD_PREFIX."$1",$query);
	return $return;
}

function bdd_query($query, $dev = false){
	global $bdd_activ;
	if($dev || OUGA_ERROR_LEVEL >= 2){
		global $variables;
		if(is_array($query)){
			foreach($query as $q)
				$variables['flash_messages']['ouga_logs'][] = $q;
		}else $variables['flash_messages']['ouga_logs'][] = $query;
	}

	if(is_array($query)){
		$result = array();
		$i = 0;

		if(!is_array($dev) && $dev){
			$dev = array_fill(0, sizeof($query), true);
		}

		foreach($query as $q){
			if($dev[$i])
				$result[] = mysql_query(bdd_add_prefix($q), $bdd_activ) or die('Module: '.$variables['module'].'<br/>Query (q): '.$q.'<br/>'.mysql_error());
			else
				$result[] = mysql_query(bdd_add_prefix($q), $bdd_activ);
			$i++;
		}
	}else{
		if($dev)
			$result = mysql_query(bdd_add_prefix($query), $bdd_activ) or die('Module: '.$variables['module'].'<br/>Query: '.$query.'<br/>'.mysql_error());
		else
			$result = mysql_query(bdd_add_prefix($query), $bdd_activ);
	}

	return $result;
}

function bdd_fetch($contenu){
	if(is_array($contenu)){
		$result = array();
		foreach($contenu as $c){
			$result[] = mysql_fetch_assoc($c);
		}
	}else{
		$result = mysql_fetch_assoc($contenu);
	}
	return $result;
}

function bdd_count($flag = 'aff', $result = null){
	global $bdd_activ;

	switch($flag){
		case 'num' : if($result != null) return mysql_num_rows($result);
		case 'aff' :
		default : return mysql_affected_rows($bdd_activ);
	}
	return false;

}

function bdd_last_id(){
	global $bdd_activ;
	return mysql_insert_id($bdd_activ);
}

/**
 * Return the query string for an array model of this query
 * @return string
 * @param data array The array to transform in string
 */
function parse_query_array($data){

	$query = '';

	switch($data['type']){
		case 'create':
			$query .= 'CREATE TABLE `{'.$data['table'].'}` (';
			foreach($data['fields'] as $field => $spec){

				$query .= '`'.$field.'` ';

				switch($spec['type']){
					case 'varchar' :
						if($spec['length'] && $spec['length'] < 255) $query .= 'varchar('.$spec['length'].')';
						else $query .= 'varchar(255)';
						break;
					case 'int' :
						if($spec['length'] && $spec['length'] < 11) $query .= 'int('.$spec['length'].')';
						else $query .= 'int(11)';
						break;
					case 'bool' :
						$query .= 'int(1)';
						break;
					case 'text' :
						$query .= 'text';
						break;
					case 'varchar' :
					default :
						if($spec['length'] && $spec['length'] < 255) $query .= 'varchar('.$spec['length'].')';
						else $query .= 'varchar(255)';
				}

				if(!$spec['null']) $query .= ' NOT NULL';

				if($spec['default'] != '') $query .= " default '".$spec['default']."'";

				if($spec['auto_inc']) $query .= ' auto_increment';

				$query .= ',';
			}

			if(is_array($data['primary_key'])){
				foreach($data['primary_key'] as $k) $key .= '`'.$k.'`,';
				$query .= ' PRIMARY KEY ('.substr($key, 0, -1).')';
			}else if($data['primary_key'] != ''){
				$query .= ' PRIMARY KEY ('.$data['primary_key'].')';
			}else{
				$query = substr($query, 0, -1);
			}

			if($data['sep'] != '') $query .= ')'.$sep;
			else $query .= ');';

			break;
		case 'delete':
			$query .= 'DELETE FROM {'.$data['table'].'} ';
			break;
		case 'insert':
			$query .= 'INSERT INTO {'.$data['table'].'} (';
			break;
		case 'select':
		default:
			$query .= '{'.$data['table'].'}';
			return;
	}

	return $query;
}

// we launche a db connection at inclusion
connectbdd();
?>
