<?php
/*
 * Copyright (c) 2009, The members of Ouga! project
 * Etienne Deparis <etienne.deparis@umaneti.net>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 *
 * modification, are permitted provided that the following conditions are
 * met:
 *  - Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  - Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *  - Neither the name of the Ouga! project nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

// il faut bien commencer par le minimum
session_start();

if(file_exists('repository/'.$_SERVER['SERVER_NAME'].'/config.php'))
	require_once 'repository/'.$_SERVER['SERVER_NAME'].'/config.php';
else require_once 'repository/default/config.php';

// List of all available components
$components = array_slice(scandir('core/components'), 2);
// Instantiate all components
foreach($components as $c){
	require_once 'core/components/'.$c;
	$className = substr($c, 0, -4);
	${$className} = new $className();
}

foreach($boot_sequence as $b){
	require_once 'core/lib/lib_'.$b.'.php';
}

if(isset($variables['path'][1]) && !empty($variables['path'][1])){
	$variables['page'] = $variables['path'][1];
}else{
	$variables['page'] = '<none>';
}
$variables['module'] = $variables['path'][0];

run_hook(0, $variables);

if(!in_array($variables['module'], $variables['modules_list'])){
	//if the module doesn't exist... we use the default callback.
	$path_old = $variables['path'];
	$variables['path'] = explode('/', OUGA_DEFAULT_FALLBACK_PATH);
	$counter = 0;

	foreach($variables['path'] as $blob){
		if(preg_match('#arg([0-9]+)#i', $blob, $matches))
			$variables['path'][$counter] = $path_old[$matches[1]];
		if($counter == 0) $variables['module'] = $blob;
		if($counter == 1) $variables['page'] = $blob;
		$counter++;
	}

}

require_once $variables['controller_file'];
?>
