<?php
/*
 * Copyright (c) 2009, The members of Ouga! project
 * Etienne Deparis <etienne.deparis@umaneti.net>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 *
 * modification, are permitted provided that the following conditions are
 * met:
 *  - Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  - Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *  - Neither the name of the Ouga! project nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

function __($trad,$arrayval){
	$u = 1;
	foreach($arrayval as $var){
		$trad = str_replace('%'.$u, $var, $trad);
		$u++;
	}
	return $trad;
}

function set_locale($locale){
	putenv('LC_ALL=' . $locale . '.UTF8');
	setlocale(LC_ALL, $locale . '.UTF8');
}

function add_lang_path($path, $type = 'module') {
	if (is_array($path)) {
		foreach($path as $p){
			if($p[0]) bindtextdomain($p[1], $p[0]);
		}
	} else {
		if ($path) bindtextdomain($type, $path);
	}
}

function set_lang($type) {
	if (textdomain(null) != $type){
		return textdomain($type);
	}
}

$variables['lang_prefix'] = array();
$variables['lang_available'] = array();

foreach($ouga_supported_languages as $prefix => $lang){
	$variables['lang_prefix'][$lang[0]] = $prefix;
	$variables['lang_available'][$prefix] = $lang[1];
}
// We look for lang specific request
if(array_key_exists($variables['path'][0], $variables['lang_prefix'])){
	set_locale($variables['lang_prefix'][$variables['path'][0]]);

	if(OUGA_ERROR_LEVEL >= 2){
		$variables['flash_messages']['ouga_logs'][]
			= 'Switch to locale: '
				. $variables['lang_prefix'][$variables['path'][0]];
	}

	if(sizeof($variables['path']) == 1){
		$variables['path'] = explode('/', OUGA_DEFAULT_HOME);
	}else{
		$variables['path'] = array_slice(
			$variables['path'],
			1,
			sizeof($variables['path'])
		);
	}
}else set_locale(OUGA_DEFAULT_LANG);
?>
