<?php
/*
 * Copyright (c) 2009, The members of Ouga! project
 * Etienne Deparis <etienne.deparis@umaneti.net>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 *
 * modification, are permitted provided that the following conditions are
 * met:
 *  - Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  - Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *  - Neither the name of the Ouga! project nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

// The theme you want to apply to your Ouga installation
define('OUGA_THEME','ouga');
// Name of the module to use for the default home page
define('OUGA_DEFAULT_HOME','home');
// Main name of your ouga site (shown in page title)
define('OUGA_NAME','Ouga!');

// Database settings
define('OUGA_BDD_HOSTNAME','');
define('OUGA_BDD_NAME','');
define('OUGA_BDD_USERNAME','');
define('OUGA_BDD_PASSWORD','');
define('OUGA_BDD_PREFIX','');

// LDAP configuration (optional)
define('OUGA_LDAP_HOSTNAME','');
define('OUGA_LDAP_USERNAME','');
define('OUGA_LDAP_PASSWORD','');
define('OUGA_LDAP_PORT',389);
define('OUGA_LDAP_ROOT','');
define('OUGA_LDAP_PASSENTRY','');
define('OUGA_LDAP_HASH','SHA1');

// Language settings
define('OUGA_DEFAULT_LANG','fr_FR');
$ouga_supported_languages = array(
	'fr_FR' => array('fr', 'Français'),
	'en_US' => array('en', 'English')
);

// Path to Ouga! top level directory
define('OUGA_BASE_PATH', '/');
// Use nice URLs (requires mod_rewrite, see .htaccess)
define('OUGA_CLEAN_URL', true);

// Default fallback path when the requested path is wrong
define('OUGA_DEFAULT_FALLBACK_PATH', 'user/profile/arg0');

// Should Ouga! load modules from the default repository on all sites ?
define('OUGA_USE_DEFAULT', true);

// Custom launch sequence
$boot_sequence = array('core','error','bdd','variables','modules','lang');

// If > 1, you will get detailed errors
define('OUGA_ERROR_LEVEL', 42);
// Security: Use ACL or not default is true
define('OUGA_USE_ACL', true);

// Don't touch the following lines
define('OUGA_VERSION', 0.2);
define('OUGA_CODENAME', 'icare');
define('OUGA_BUILD_STEP', true);
?>
