<?php
/*
 * Copyright (c) 2009, The members of Ouga! project
 * Etienne Deparis <etienne.deparis@umaneti.net>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 *
 * modification, are permitted provided that the following conditions are
 * met:
 *  - Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  - Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *  - Neither the name of the Ouga! project nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

function document_init(&$variables){

	if($variables['page'] == '<none>') $variables['page'] = 'list';
	if($variables['page'] == 'tags')
		component('acl')->check(
			$variables['user']->login,
			'document/tags/#'
		);

	use_modele('document');

	$variables['header']['style']['screen'][]
		= path_to_module('document').'views/inc/style.css';

}

function document_edit(&$variables){

	$variables['article'] = new document(get_arg(2));

	if(get_arg(2) == 'new'
		|| $variables['article']->author == $variables['user']->login
		|| component('acl')->check(
			$variables['user']->login,
			'document/admin/all'
		)
	){
		$variables['header']['script'][] = path_to_module('document')
			. 'views/inc/widgEditor.js';
		$variables['header']['script'][] = path_to_module('document')
			. 'views/inc/document.js';
		$variables['header']['style']['screen'][]
			= path_to_module('document').'views/inc/widgEditor.css';
		$variables['article'] = new document(get_arg(2));

		if($variables['article']->title == "")
			$variables['article']->title = _('Document without title');

	}else throw_error(403);
}

function document_submit(&$variables){

	if(isset($_FILES['fileup'])){
		$url = 'new-file';
		if(empty($_POST['title'])) $title = $_FILES['fileup']['name'];
		else $title = $_POST['title'];

		$page = new document($_POST['did'], array(
												'url' => $url,
												'title' => $title,
												'content' => '',
												'author' => $variables['user']->login,
												'tags' => $_POST['tags'],
												'type' => $_POST['type'])
						);
		header('location: '.$page->save());
		exit;
	}else throw_error('fatal/8');
}

function document_save(&$variables){
	if(isset($_POST['title']) &&
	   isset($_POST['article']) &&
	   !empty($_POST['title']) &&
	   !empty($_POST['title'])){

		$page = new document($_POST['did'], array(
												'url' => false,
												'title' => $_POST['title'],
												'content' => $_POST['article'],
												'author' => $variables['user']->login,
												'tags' => $_POST['tags'],
												'type' => $_POST['type'])
						);
		header('location: '.$page->save());
		exit;
	}else throw_error('fatal/8');
}

function document_delete(&$variables, $did = null){
	if($did == null) $did = strclean(get_arg(2));

	$page = new document($did);
	if($page != null && $page->did != 'new'){
		$page->delete();
		if($variables['from-form'] == null){
			header('location: '.base_path().'document/admin');exit;
		}
	}
}

function document_ajax(&$variables){
	if(isset($_POST['texte'])){
		$article = new document('new');
		$article->content = strclean($_POST['texte']);
		print $article->get_content();
	}
	exit;
}

function document_list(&$variables){

	$variables['page'] = 'admin';

	$variables['pager'] = document_get_pager();
	if(get_arg(2)) $shift = get_arg(2) * DOCUMENT_ARTICLES_PER_PAGE;
	else $shift = 0;

	$variables['header']['script'][] = path_to_module('document')
		. 'views/inc/lib_list.js';
	$variables['articles_list'] = load_array_of_document(
		30,
		'author = \'' . $variables['user']->login . '\'',
		'date desc',
		'*',
		$shift
	);
}

function document_admin(&$variables){

	$variables['pager'] = document_get_pager();
	if(get_arg(2)) $shift = get_arg(2) * DOCUMENT_ARTICLES_PER_PAGE;
	else $shift = 0;

	$variables['header']['script'][] = path_to_module('document')
		. 'views/inc/lib_list.js';
	$variables['articles_list'] = load_array_of_document(
		30,
		'',
		'date desc',
		'*',
		$shift
	);
}

function document_tags(&$variables){

	$variables['pager'] = document_get_pager();
	if(get_arg(3)) $shift = get_arg(3) * DOCUMENT_ARTICLES_PER_PAGE;
	else $shift = 0;

	if(get_arg(3)) $author = 'author = \''.strclean(get_arg(3)).'\'';
	else $author = '';

	$tag = get_arg(2);
	$variables['articles_list'] = load_array_of_document(
		30,
		"tags like '%$tag%'",
		'date desc',
		'*',
		$shift
	);
	$variables['page'] = 'admin';
}

function document_groupdo(&$variables){
	$iddocs = $_POST['document'];
	$action = strclean($_POST['action']);
	$variables['from-form'] = true;
	switch($action){
		case 'published' :
						foreach($iddocs as $did)
							bdd_query("update {documents} set type = '"
								. DOCUMENT_PUBLISHED
								. "' where did = $did"
							);
						break;
		case 'private' :
						foreach($iddocs as $did)
							bdd_query("update {documents} set type = '"
								. DOCUMENT_PRIVATE
								. "' where did = $did"
							);
						break;
		case 'draft' :
						foreach($iddocs as $did)
							bdd_query("update {documents} set type = '"
								. DOCUMENT_DRAFT
								. "' where did = $did"
							);
						break;
		case 'delete' :
						foreach($iddocs as $did)
							document_delete($variables, $did);
						break;
	}
	header('location: '.base_path().'document');exit;
}

function document_document(&$variables){

	$idarti = strclean(get_arg(1));
	$page = new document($idarti);

	if($page->get_type() == DOCUMENT_PUBLISHED
		|| $page->author == $variables['user']->login
		|| component('acl')->check(
			$variables['user']->login,
			'document/admin/all'
		)
	){
		$variables['article'] = $page;

		$variables['page'] = 'page';
	}else throw_error(403);
}
?>
