<?php

function document_dbmodel(){
	return array(
		'documents' => array(
			'fields' => array(
				'did' => array(
					'type' => 'int',
					'length' => 11,
					'null' => false,
					'auto_inc' => true
				),
				'url' => array(
					'type' => 'text',
					'null' => false
				),
				'title' => array(
					'type' => 'varchar',
					'length' => 255,
					'null' => false
				),
				'content' => array(
					'type' => 'text',
					'null' => false
				),
				'author' => array(
					'type' => 'varchar',
					'length' => 255,
					'null' => false
				),
				'date' => array(
					'type' => 'int',
					'length' => 11,
					'null' => false
				),
				'tags' => array(
					'type' => 'text',
					'null' => false
				),
				'type' => array(
					'type' => 'int',
					'length' => 1,
					'null' => false,
					'default' => 2
				),

			),
			'primary_key' => 'did'
		),
		'tags' => array(
			'fields' => array(
				'tag' => array(
					'type' => 'varchar',
					'length' => 255,
					'null' => false
				),
				'weight' => array(
					'type' => 'int',
					'length' => 11,
					'null' => false
				)
			),
			'primary_key' => 'tag'
		),
	);
}

function document_acl_install(){
	return array(
		'primary' => array(
			'document/edit/#' => 'Per user documents administration',
			'document/admin' => 'Overall documents administration',
		),
		'copy' => array(
			'document/admin/#' => 'document/admin',
			'document/list' => 'document/edit/#',
			'document/list/#' => 'document/edit/#',
			'document/submit' => 'document/edit/#',
			'document/save' => 'document/edit/#',
			'document/delete/#' => 'document/edit/#',
			'document/ajax' => 'document/edit/#',
			'document/admin' => 'document/edit/#',
			'document/admin/#' => 'document/edit/#',
			'document/tags/#' => 'document/edit/#',
			'document/groupdo' => 'document/edit/#',
		)
	);
}

function document_install(&$variables){

}

function document_uninstall(&$variables){
	$queries = array("drop table {documents}","drop table {tags}");
	bdd_query($queries);
}

?>
