<?php
/*
 * Copyright (c) 2009, The members of Ouga! project
 * Etienne Deparis <etienne.deparis@umaneti.net>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 *
 * modification, are permitted provided that the following conditions are
 * met:
 *  - Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  - Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *  - Neither the name of the Ouga! project nor the names of its
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

class text{

	public $value;
	public $parsedValue;

	public function __construct($text = null){
		if($text != null){
			$this->value = $text;
			$this->parsedValue = $this->parse();
		}
	}

	public function affiche_simple_date($date = null){
		if($date == null)
			$date = date("YmdHis", $this->value);
		else
			$date = date("YmdHis", $date);
		$lang = get_locale();
		$an = substr($date,0,4);
		$mois = substr($date,4,2);
		$jour = substr($date,6,2);
		$heure = substr($date,8,2);
		$min = substr($date,10,2);
		$sec = substr($date,12,2);
		if($lang == 'en_US')
			return $mois.'/'.$jour.'/'.$an.' at '.$heure.':'.$min;
		return $jour.'/'.$mois.'/'.$an.' à '.$heure.':'.$min;
	}

	public function affiche_date($date = null){
		if($date == null)
			$date = date("YmdHis", $this->value);
		else
			$date = date("YmdHis", $date);
		$lang = get_locale();
		$date = date("YmdHis", $this->value);
		$an = substr($date,0,4);
		$mois = substr($date,4,2);
		$jour = substr($date,6,2);
		$heure = substr($date,8,2);
		$min = substr($date,10,2);
		$sec = substr($date,12,2);
		$date = mktime($heure,$min,$sec,$mois,$jour,$an);

		$tabjourfr = array('Dimanche','Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi');
		$tabjouren = array('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
		$tabmoisfr = array('Janvier','Février','Mars','Avril','Mai','Juin','Juillet','Août','Septembre','Octobre','Novembre','Décembre');
		$tabmoisen = array('Januar','Februar','March','April','May','Juny','July','August','September','October','November','December');

		$numjour=date('w',$date);
		if($lang == 'en_US'){
			$jourok= $tabjouren[$numjour];
			$mois--;
			$moisok= $tabmoisen[$mois];
			return $jourok.' '.$jour.' '.$moisok.' '.$an.' at '.$heure.':'.$min;
		}
		$jourok= $tabjourfr[$numjour];
		$mois--;
		$moisok= $tabmoisfr[$mois];
		return $jourok.' '.$jour.' '.$moisok.' '.$an.' à '.$heure.':'.$min;
	}

	public function manageRes($matches){

		$i = sizeof($matches);

		$url = $matches[1];
		$format = substr(strtolower($url),-4);
		switch($format){
			case 'jpeg' :
			case '.jpg' :
			case '.png' :
			case '.gif' :
				$urltab = explode('/', $url);
				$i = sizeof($urltab) - 1;
				$urltab[$i] = 'mini_'.$urltab[$i];
				$output = '<a href="'.$url.'"><img src="'.implode('/', $urltab).'"';
				switch($i){
					case 4 : $output .= ' alt="'.$matches[2].'" style="'.$matches[3].'"/>'; break;
					case 3 : $output .= ' alt="'.$matches[2].'"/>'; break;
					case 2 :
					default : $output .= ' alt=""/></a>';
				}
				break;
			case '.pdf' :
				$output = '<a href="'.$url.'"><img src="'.path_to_module('document').'img/page_white_acrobat.png" alt=""/> Download it</a>';
				break;
			case '.doc' :
				$output = '<a href="'.$url.'"><img src="'.path_to_module('document').'img/page_white_word.png" alt=""/> Download it</a>';
				break;
			default :
				$output = '<a href="'.$url.'">Download it</a>';
		}
		return $output;
	}

	public function manageLink($matches){

		$output = '<a href="';
		if($matches[1] == null || $matches[1] == '') return $matches[0];

		$output .= $matches[1].'"';

		switch(sizeof($matches)){
			case 3 : $output .= '>'.$matches[2]; break;
			case 4 : $output .= ' hreflang="'.$matches[3].'">'.$matches[2]; break;
			case 5 : $output .= ' hreflang="'.$matches[3].'" style="'.$matches[4].'">'.$matches[2]; break;
			case 2 :
			default : $output .= '>'.$matches[1];
		}

		return $output.'</a>';
	}

	public function parse($text = null){

		// On transforme tout ce qu'il y a à transformer
		if($text == null) $text = $this->value . "\r\n";
		else $text .= "\r\n";
		$text = preg_replace('#^ - (.+)$#iUm',"<li>$1</li>",$text);
		$text = preg_replace('#</li>(?:\r|\n)*<li>#i',"</li><li>",$text);
		$text = preg_replace('#(<li>(?:.+)</li>)+#i',"<ul>$0</ul>",$text);
		$text = preg_replace_callback('#{{([^]]+)(?:\|(.+)(?:\|(.+)(?:\|(.+))?)?)?}}#iU', array($this, 'manageRes'), $text);
		$text = preg_replace_callback('#\[\[([^]]+)(?:\|(.+)(?:\|(.+)(?:\|(.+))?)?)?\]\]#iU', array($this, 'manageLink'), $text);
		$text = preg_replace('#\[quote=(.[^\]]+)\]#iU',"<blockquote><strong>$1 a dit :</strong><br/>",$text);
		$text = preg_replace('#\[/quote\]#iU',"</blockquote>",$text);
		$text = preg_replace('#\[code\]#iU',"<code>",$text);
		$text = preg_replace('#\[/code\]#iU',"</code>",$text);
		$text = preg_replace('#\*\*(.+)\*\*#iU',"<strong>$1</strong>",$text);
		$text = preg_replace('#_(.+)_#iU',"<em>$1</em> ",$text);
		$text = preg_replace('#__(.+)__#iU',"<span style=\"text-decoration:underline;\">$1</span>",$text);
		$text = preg_replace('#\$\$(.+)\$\$#iU',"<span style=\"text-decoration:line-through;\">$1</span>",$text);
		$text = preg_replace('#===(.+)===(\r\n)+#iU',"<h3>$1</h3><p>",$text);
		$text = preg_replace('#==(.[^=]+)==(\r\n)+#iU',"<h2>$1</h2><p>",$text);

		$pattern = array('^^', ':(', ':&#39;(', ':\'(', ':)', ';)', ':p', ':D',
						 '(l)', '(hug)', '(biz)', 'Oo', ':s', ':$', '*-)', '(lol)', '(tux)');
		$replace = array('<img src="'.path_to_theme().'img/smiley/joyful.png" alt="^^" />',
						 '<img src="'.path_to_theme().'img/smiley/sad.png" alt=":(" />',
						 '<img src="'.path_to_theme().'img/smiley/crying.png" alt=":\'(" />',
						 '<img src="'.path_to_theme().'img/smiley/crying.png" alt=":\'(" />',
						 '<img src="'.path_to_theme().'img/smiley/smile.png" alt=":)" />',
						 '<img src="'.path_to_theme().'img/smiley/wink.png" alt=";)" />',
						 '<img src="'.path_to_theme().'img/smiley/tongue.png" alt=":p\" />',
						 '<img src="'.path_to_theme().'img/smiley/grin.png" alt=":D" />',
						 '<img src="'.path_to_theme().'img/smiley/love.png" alt="(l)" />',
						 '<img src="'.path_to_theme().'img/smiley/calin.gif" alt="(calin)" />',
						 '<img src="'.path_to_theme().'img/smiley/biz.gif" alt="(biz)" />',
						 '<img src="'.path_to_theme().'img/smiley/andy.png" alt="Oo" />',
						 '<img src="'.path_to_theme().'img/smiley/unsure.png" alt=":s" />',
						 '<img src="'.path_to_theme().'img/smiley/blushing.png" alt=":$" />',
						 '<img src="'.path_to_theme().'img/smiley/wondering.png" alt="*-)" />',
						 '<img src="'.path_to_theme().'img/smiley/lol.jpg" alt="lol" />',
						 '<img src="'.path_to_theme().'img/smiley/tux.png" alt="tux" />');
		$text = str_replace($pattern, $replace, $text);

		// nettoyage
		//$text = preg_replace("#\r#iU","/r",$text);
		//$text = preg_replace("#\n#iU","/n",$text);
		$text = preg_replace("#(\r\n){2,}|(\n\n)+#iU","</p><p>",$text);
		$text = preg_replace("#\r?\n#iU",'<br/>',$text);
		$text = preg_replace("#\<p\>\<(h\d)\>#iU",'<$1>',$text);
		$text = preg_replace("#\<p\>\<ul\>#iU",'<ul>',$text);
		$text = preg_replace("#\<(\w{1,4})\>\<br/\>#iU",'<$1>',$text);

		if(substr($text, 0, 3) != '<p>') $text = '<p>'.$text;
		if(substr($text, -5) == '<br/>') $text = substr($text, 0, -5);
		if(substr($text, -5) != '</ul>' && substr($text, -4) != '</p>' &&
		   substr($text, -7) != '</code>' && substr($text, -13) != '</blockquote>') $text = $text.'</p>';

		return $text;
	}

	public function parseTitle($title = null){
		if($title == null) $t = $this->value;
		else $t = $title;
		return strtoascii($t);
	}

	public function createHTMLEditor($defaultContent = ''){
	}
}

?>
