<?php
/*
 * Copyright (c) 2009, The members of Ouga! project
 * Etienne Deparis <etienne.deparis@umaneti.net>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 *
 * modification, are permitted provided that the following conditions
 * are met:
 *  - Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  - Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  - Neither the name of the Ouga! project nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

$module_title = _('ACL Groups rights management');
$modmenucontents = array(
	'group' => _('Groups management'),
	'group/rights' => _('Rights management')
);

?>


<h2><?php echo _('Rights management'); ?></h2>
<form action="<?php echo base_path(); ?>group/do" method="post">
	<fieldset>
		<input type="hidden" name="action" value="chggrprights" />
		<table id="grouprightstable">
			<?php
			$groupsbar = '';
			foreach($groups as $g){
				$groupsbar .= '<th>' . $g['label'] . '</th>';
			}

			foreach($rightlist as $path => $desc){
				echo '<tr><th></th>' . $groupsbar . '<th>'
					. _('Note') . '</th></tr>';

				echo '<tr><td class="groupname">' . $desc[0] . '</td>';
				$note = '';
				foreach($groups as $g){
					echo '<td><input type="checkbox"
						name="rights[' . $path . '][]"
						value="' . $g['aid'] . '"';

					if(!is_numeric($desc[1])
						&& in_array($g['aid'], unserialize($desc[1]))){
							echo ' checked="checked"';
					}else if($desc[1] == $g['aid']){
						echo ' checked="checked"';
					}
					echo ' /></td>';

					if($desc[1] === 0 || $desc[1] === '0'){
						$note = '<span style="color:red;">'
							. _('All visitors can access these functions')
							. '</span>';
					}
				}
				if($note) echo '<td style="width:200px;">' . $note . '</td>';
				else echo '<td></td>';
				echo '</tr>';
			} ?>
		</table>
		<p><? echo _('I want now to be part of'); ?>
		<select name="grpchg">
			<? foreach($groups as $g){
				echo '<option value="' . $g['aid'] . '">'
					. $g['label'] . '</option>';
			} ?>
		</select>
		<input type="submit" value="<?php echo _('Submit changes'); ?>"/>
	</fieldset>
</form>
